#include <stdio.h>
#include "lex.yy.h"
#include "te_node.h"

extern int yyparse (void);
extern int yydebug;
extern int type_table_put(char *, te_node *);
extern void free_type_table(void);
extern void free_var_table(void);

void yyerror(char const *message){
  printf("%s", message);
}

int main(int argc, char const *argv[]) {
  yyin = fopen(argv[1], "r");
  yydebug = 0;
  type_table_put("int", te_make_base(1));
  type_table_put("float", te_make_base(2));
  type_table_put("char", te_make_base(3));
  type_table_put("double", te_make_base(4));
  int result_code = yyparse();
  free_var_table();
  free_type_table();
  fclose(yyin);
  return result_code;
}
