%option header-file="lex.yy.h"
%option noyywrap

%top{
  /* This goes at the top of the generated file */
  #include "parser.tab.h"
  #include "te_node.h"
  #include <string.h>
  extern YYSTYPE yylval;
  extern type_entry *type_table_get(char *name);
}

INTEGER [1-9][0-9]*|0
ID [A-Za-z_][0-9A-Za-z_]*
COMMENT "/*"([^*]*|"*"+[^*/])"*"+\/
TYPES	int|float|double|char

%%

{TYPES} { yylval.te = type_table_get(yytext)->type; return TYPE; }

{COMMENT} { /* Elimination of comments */; }

{ID} { yylval.string = strdup(yytext); return ID;}

{INTEGER} { yylval.int_value = atoi(yytext); return NUM;}

"*" {return TIMES;}
"[" {return SO;}
"]" {return SC;}
";" {return S;}
"," {return CM;}
\r|\n|\r\n {;}
. {;}
