#ifndef TE_NODE_H
#define TE_NODE_H 

#define TEBASETYPE 1
#define TEARRAY 3
#define TEPOINTER 6

/* Uncomment for struct and typedef 
#define TENAME 2
#define TEPRODUCT 4
#define TESTRUCT 5
#define TEFUNCTION 7
#define TEFWDSTRUCT 8 // incomplete structure
#define IS_VAR 1
#define IS_FIELD 2
#define IS_TYPEDEF 3 
*/


typedef struct te_node {
    int tag;
    int size;
    int code;
    struct te_node *left;
    struct te_node *right;
    /* Uncomment for struct and typedef 
    char *name;
    int ival;
    */
} te_node;

te_node *te_make_base(int code);
te_node *te_make_pointer(te_node *base);
te_node *te_make_array(int size, te_node *base);
/* Uncomment for struct and typedef 
te_node *te_make_name(char *name);
te_node *te_make_product(te_node *left, te_node *right);
te_node *te_make_fwdstruct(char *name);
int te_is_fwd(te_node *str);
void te_cons_struct(te_node *str, te_node *fields);
te_node *te_make_struct(te_node *fields, char *name);
te_node *te_make_function(te_node *domain, te_node *range);
*/
void te_print(te_node *node);
void te_free(te_node *node);

#endif